/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef ARCHPROCESSORINTERFACE_20070717_H_
#define ARCHPROCESSORINTERFACE_20070717_H_

#include "Types.h"
#include <QStringList>

class QCategoryList;
class QTreeWidgetItem;
class QString;
class QByteArray;
class State;

class ArchProcessorInterface {
public:
	virtual ~ArchProcessorInterface() {}
public:
	virtual void setupRegisterView(QCategoryList *catagoryList) = 0;
	virtual void reset() = 0;
	virtual void updateRegisterView(const QString &defaultRegionName) = 0;
	virtual QStringList updateInstructionInfo(edb::address_t address) = 0;
	virtual edb::reg_t *valueFromItem(const QTreeWidgetItem &item, unsigned int mode) = 0;
	
public:
	// instruction inspection
	virtual bool isFilling(const edb::Instruction &insn) const = 0;
	virtual bool canStepOver(const edb::Instruction &insn) const = 0;
	virtual edb::address_t getEffectiveAddress(const edb::Operand &op) const = 0;
	virtual edb::address_t getEffectiveAddress(const edb::Operand &op, const State &state) const = 0;
};

#endif

